{-|
Module      : Gargantext.Utils.Array
Description : Gargantext utilities
Copyright   : (c) CNRS, 2017
License     : AGPL + CECILL v3
Maintainer  : team@gargantext.org
Stability   : experimental
Portability : POSIX

Utilities for handling arrays.
-}

module Gargantext.Utils.Array where


import Protolude


-- | A sliding window of given size for an array.
-- https://stackoverflow.com/questions/27726739/implementing-an-efficient-sliding-window-algorithm-in-haskell
window :: Int -> [a] -> [[a]]
window size = foldr (zipWith (:)) (repeat []) . take size . tails
